
//  Pallo.java  (c) Kari Laitinen

//  http://www.naturalprogramming.com

//  2003-04-14  Tiedosto luotu.
//  2009-11-03  Viimeisin muutos.

//  Tata luokkaa hyodynnetaan ohjelmassa
//  PalloLiikkuuHiirellaApplet.java.

import java.awt.* ;
import java.awt.geom.* ;

class Pallo
{
   int pallon_keskipiste_x  =  0 ;
   int pallon_keskipiste_y  =  0 ;

   Color pallon_vari  =  Color.red ;

   int pallon_halkaisija  =  100 ;

   boolean  pallo_on_aktivoitu  =  false ;

   public Pallo( int annettu_paikka_x,
                 int annettu_paikka_y,
                 Color annettu_vari )
   {
      pallon_keskipiste_x  =  annettu_paikka_x ;
      pallon_keskipiste_y  =  annettu_paikka_y ;
      pallon_vari      =  annettu_vari ;
   }

   public void aktivoi_pallo()
   {
      pallo_on_aktivoitu  =  true ;
   }

   public void deaktivoi_pallo()
   {
      pallo_on_aktivoitu  =  false ;
   }



   int lue_pallon_keskipiste_x()
   {
      return pallon_keskipiste_x ;
   }

   int lue_pallon_keskipiste_y()
   {
      return pallon_keskipiste_y ;
   }

   public int lue_pallon_halkaisija()
   {
      return pallon_halkaisija ;
   }

   public void siirra_oikealle()
   {
      pallon_keskipiste_x  +=  3 ;
   }

   public void siirra_vasemmalle()
   {
      pallon_keskipiste_x  -=  3 ;
   }

   public void siirra_ylos()
   {
      pallon_keskipiste_y  -=  3 ;
   }

   public void siirra_alas()
   {
      pallon_keskipiste_y  +=  3 ;
   }


   public void  siirra_palloa( int siirtyma_suunnassa_x,
                               int siirtyma_suunnassa_y )
   {
      pallon_keskipiste_x  =  pallon_keskipiste_x  +  siirtyma_suunnassa_x ;
      pallon_keskipiste_y  =  pallon_keskipiste_y  +  siirtyma_suunnassa_y ;
   }

   //  Seuraavaa metodia kaytetaan kun pallon paikkaa
   //  halutaan muuttaa radikaalisti ruudulla.

   public void muuta_pallon_paikka( int uusi_paikka_x,
                                    int uusi_paikka_y )
   {
      pallon_keskipiste_x  =  uusi_paikka_x ;
      pallon_keskipiste_y  =  uusi_paikka_y ;
   }



   public void pienenna()
   {
      //  if-rakenteella varmistetaan etta pallo ei
      //  mene liian pieneksi.

      if ( pallon_halkaisija  > 10 )
      {
         pallon_halkaisija  -=  6 ;

      }
   }


   public void suurenna()
   {
      pallon_halkaisija  +=  6 ;

   }

   // Myos seuraavalla metodilla voi muuttaa pallo-olion
   // kokoa.

   public void muuta_halkaisija( int uusi_halkaisija )
   {
      if ( uusi_halkaisija  >  5 )
      {
         pallon_halkaisija  =  uusi_halkaisija ;

      }
   }

   public void muuta_vari( Color uusi_vari )
   {
      pallon_vari  =  uusi_vari ;
   }

   public boolean piste_on_pallolla( Point annettu_piste )
   {
      Area  taman_pallon_alue  =  new  Area(

            new  Ellipse2D.Float( pallon_keskipiste_x - pallon_halkaisija / 2,
                                  pallon_keskipiste_y - pallon_halkaisija / 2,
                                  pallon_halkaisija,
                                  pallon_halkaisija ) ) ;

      return taman_pallon_alue.contains( annettu_piste.x,
                                         annettu_piste.y  ) ;
   }

   public void piirra( Graphics graphics )
   {
      graphics.setColor( pallon_vari ) ;

      graphics.fillOval( pallon_keskipiste_x - pallon_halkaisija / 2,
                         pallon_keskipiste_y - pallon_halkaisija / 2,
                         pallon_halkaisija, pallon_halkaisija ) ;

      graphics.setColor( Color.black ) ;

      graphics.drawOval( pallon_keskipiste_x - pallon_halkaisija / 2,
                         pallon_keskipiste_y - pallon_halkaisija / 2,
                         pallon_halkaisija, pallon_halkaisija ) ;

      //  If this ball is activated, it will have a thick black edge

      if ( pallo_on_aktivoitu  ==  true )
      {
         graphics.drawOval( pallon_keskipiste_x - pallon_halkaisija / 2 + 1,
                            pallon_keskipiste_y - pallon_halkaisija / 2 + 1,
                            pallon_halkaisija - 2, pallon_halkaisija - 2 ) ;

         graphics.drawOval( pallon_keskipiste_x - pallon_halkaisija / 2 + 2,
                            pallon_keskipiste_y - pallon_halkaisija / 2 + 2,
                            pallon_halkaisija - 4, pallon_halkaisija - 4 ) ;
      }
   }

}


